Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/ICE/icectl.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/ICE/icectl.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/ICE/icectl.F90	(revision 15648)
@@ -706,5 +706,5 @@
       CALL prt_ctl_info(' - Cell values : ')
       CALL prt_ctl_info('   ~~~~~~~~~~~~~ ')
-      CALL prt_ctl(tab2d_1=CASTWP(e1e2t)      , clinfo1=' cell area   :')
+      CALL prt_ctl(tab2d_1=CASTDP(e1e2t)      , clinfo1=' cell area   :')
       CALL prt_ctl(tab2d_1=at_i       , clinfo1=' at_i        :')
       CALL prt_ctl(tab2d_1=ato_i      , clinfo1=' ato_i       :')
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/ICE/icerst.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/ICE/icerst.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/ICE/icerst.F90	(revision 15648)
@@ -330,5 +330,5 @@
             !
             IF(lwp) WRITE(numout,*) '  SAS: default initialisation of ss[st]_m arrays used in ice_istate'
-            IF( l_useCT )  THEN    ;   sst_m(:,:) = eos_pt_from_ct( CASTWP(ts(:,:,1,jp_tem, Kmm)), CASTWP(ts(:,:,1,jp_sal, Kmm)) )
+            IF( l_useCT )  THEN    ;   sst_m(:,:) = eos_pt_from_ct( CASTDP(ts(:,:,1,jp_tem, Kmm)), CASTDP(ts(:,:,1,jp_sal, Kmm)) )
             ELSE                   ;   sst_m(:,:) = ts(:,:,1,jp_tem, Kmm)
             ENDIF
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/ICE/icestp.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/ICE/icestp.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/ICE/icestp.F90	(revision 15648)
@@ -213,5 +213,5 @@
       ! --- Ocean time step --- !
       !-------------------------!
-      CALL ice_update_tau( kt, CASTWP(uu(:,:,1,Kbb)), CASTWP(vv(:,:,1,Kbb)) )         ! -- update surface ocean stresses
+      CALL ice_update_tau( kt, CASTDP(uu(:,:,1,Kbb)), CASTDP(vv(:,:,1,Kbb)) )         ! -- update surface ocean stresses
 !!gm   remark, the ocean-ice stress is not saved in ice diag call above .....  find a solution!!!
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P2Z/p2zbio.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P2Z/p2zbio.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P2Z/p2zbio.F90	(revision 15648)
@@ -369,5 +369,5 @@
          WRITE(charout, FMT="('bio')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P2Z/p2zexp.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P2Z/p2zexp.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P2Z/p2zexp.F90	(revision 15648)
@@ -142,5 +142,5 @@
          WRITE(charout, FMT="('exp')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P2Z/p2zopt.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P2Z/p2zopt.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P2Z/p2zopt.F90	(revision 15648)
@@ -127,5 +127,5 @@
          WRITE(charout, FMT="('opt')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl( tab4d_1=CASTWP(tr(:,:,:,:,Kmm)), mask1=tmask, clinfo=ctrcnm )
+         CALL prt_ctl( tab4d_1=CASTDP(tr(:,:,:,:,Kmm)), mask1=tmask, clinfo=ctrcnm )
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P2Z/p2zsed.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P2Z/p2zsed.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P2Z/p2zsed.F90	(revision 15648)
@@ -111,5 +111,5 @@
          WRITE(charout, FMT="('sed')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zagg.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zagg.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zagg.F90	(revision 15648)
@@ -172,5 +172,5 @@
          WRITE(charout, FMT="('agg')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zbio.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zbio.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zbio.F90	(revision 15648)
@@ -110,5 +110,5 @@
          WRITE(charout, FMT="('bio ')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zfechem.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zfechem.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zfechem.F90	(revision 15648)
@@ -220,5 +220,5 @@
          WRITE(charout, FMT="('fechem')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zflx.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zflx.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zflx.F90	(revision 15648)
@@ -180,5 +180,5 @@
          WRITE(charout, FMT="('flx ')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
 
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zligand.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zligand.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zligand.F90	(revision 15648)
@@ -91,5 +91,5 @@
          WRITE(charout, FMT="('ligand1')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zlys.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zlys.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zlys.F90	(revision 15648)
@@ -132,5 +132,5 @@
         WRITE(charout, FMT="('lys ')")
         CALL prt_ctl_info( charout, cdcomp = 'top' )
-        CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+        CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zmeso.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zmeso.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zmeso.F90	(revision 15648)
@@ -248,5 +248,5 @@
         WRITE(charout, FMT="('meso')")
         CALL prt_ctl_info( charout, cdcomp = 'top' )
-        CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+        CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zmicro.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zmicro.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zmicro.F90	(revision 15648)
@@ -204,5 +204,5 @@
          WRITE(charout, FMT="('micro')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zmort.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zmort.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zmort.F90	(revision 15648)
@@ -122,5 +122,5 @@
          WRITE(charout, FMT="('nano')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
        ENDIF
       !
@@ -194,5 +194,5 @@
          WRITE(charout, FMT="('diat')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zpoc.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zpoc.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zpoc.F90	(revision 15648)
@@ -244,5 +244,5 @@
         WRITE(charout, FMT="('poc1')")
         CALL prt_ctl_info( charout, cdcomp = 'top' )
-        CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+        CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
      ENDIF
 
@@ -436,5 +436,5 @@
          WRITE(charout, FMT="('poc2')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zprod.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zprod.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zprod.F90	(revision 15648)
@@ -333,5 +333,5 @@
          WRITE(charout, FMT="('prod')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
      ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zrem.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zrem.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zrem.F90	(revision 15648)
@@ -198,5 +198,5 @@
          WRITE(charout, FMT="('rem1')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
        ENDIF
 
@@ -220,5 +220,5 @@
          WRITE(charout, FMT="('rem2')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
        ENDIF
 
@@ -251,5 +251,5 @@
          WRITE(charout, FMT="('rem3')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
        ENDIF
 
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zsed.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zsed.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zsed.F90	(revision 15648)
@@ -317,5 +317,5 @@
          WRITE(charout, fmt="('sed ')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zsink.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zsink.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p4zsink.F90	(revision 15648)
@@ -146,5 +146,5 @@
          WRITE(charout, FMT="('sink')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p5zmeso.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p5zmeso.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p5zmeso.F90	(revision 15648)
@@ -361,5 +361,5 @@
         WRITE(charout, FMT="('meso')")
         CALL prt_ctl_info( charout, cdcomp = 'top' )
-        CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+        CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p5zmicro.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p5zmicro.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p5zmicro.F90	(revision 15648)
@@ -308,5 +308,5 @@
          WRITE(charout, FMT="('micro')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p5zmort.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p5zmort.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p5zmort.F90	(revision 15648)
@@ -123,5 +123,5 @@
          WRITE(charout, FMT="('nano')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
        ENDIF
       !
@@ -181,5 +181,5 @@
          WRITE(charout, FMT="('pico')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
        ENDIF
       !
@@ -256,5 +256,5 @@
          WRITE(charout, FMT="('diat')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p5zprod.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p5zprod.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/P4Z/p5zprod.F90	(revision 15648)
@@ -463,5 +463,5 @@
          WRITE(charout, FMT="('prod')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/SED/trcdmp_sed.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/SED/trcdmp_sed.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/PISCES/SED/trcdmp_sed.F90	(revision 15648)
@@ -109,5 +109,5 @@
          WRITE(charout, FMT="('dmp ')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl( tab4d_1=CASTWP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm,clinfo3='trd' )
+         CALL prt_ctl( tab4d_1=CASTDP(tr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm,clinfo3='trd' )
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcatf.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcatf.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcatf.F90	(revision 15648)
@@ -163,5 +163,5 @@
 # else
             IF( ln_linssh ) THEN   ;   CALL tra_atf_fix( kt, Kbb, Kmm, Kaa, nittrc000,         'TRC', ptr, jptra )                       !     linear ssh
-            ELSE                   ;   CALL tra_atf_vvl( kt, Kbb, Kmm, Kaa, nittrc000, CASTWP(rn_Dt), 'TRC', ptr, sbc_trc, sbc_trc_b, jptra )    ! non-linear ssh
+            ELSE                   ;   CALL tra_atf_vvl( kt, Kbb, Kmm, Kaa, nittrc000, CASTDP(rn_Dt), 'TRC', ptr, sbc_trc, sbc_trc_b, jptra )    ! non-linear ssh
 # endif
             ENDIF
@@ -187,5 +187,5 @@
          WRITE(charout, FMT="('nxt')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl(tab4d_1=CASTWP(ptr(:,:,:,:,Kmm)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl(tab4d_1=CASTDP(ptr(:,:,:,:,Kmm)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcbbl.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcbbl.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcbbl.F90	(revision 15648)
@@ -70,8 +70,8 @@
       IF( nn_bbl_ldf == 1 ) THEN
          !
-         CALL tra_bbl_dif( CASTWP(ptr(:,:,:,:,Kbb)), ptr(:,:,:,:,Krhs), jptra, Kmm )  
+         CALL tra_bbl_dif( CASTDP(ptr(:,:,:,:,Kbb)), ptr(:,:,:,:,Krhs), jptra, Kmm )  
          IF( sn_cfctl%l_prttrc )   THEN
             WRITE(charout, FMT="(' bbl_dif')")  ;  CALL prt_ctl_info( charout, cdcomp = 'top' )
-            CALL prt_ctl( tab4d_1=CASTWP(ptr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm, clinfo3='trd' )
+            CALL prt_ctl( tab4d_1=CASTDP(ptr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm, clinfo3='trd' )
          ENDIF
          !
@@ -81,8 +81,8 @@
       IF( nn_bbl_adv /= 0 ) THEN
          !
-         CALL tra_bbl_adv( CASTWP(ptr(:,:,:,:,Kbb)), ptr(:,:,:,:,Krhs), jptra, Kmm )  
+         CALL tra_bbl_adv( CASTDP(ptr(:,:,:,:,Kbb)), ptr(:,:,:,:,Krhs), jptra, Kmm )  
          IF( sn_cfctl%l_prttrc )   THEN
             WRITE(charout, FMT="(' bbl_adv')")  ;  CALL prt_ctl_info( charout, cdcomp = 'top' )
-            CALL prt_ctl( tab4d_1=CASTWP(ptr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm, clinfo3='trd' )
+            CALL prt_ctl( tab4d_1=CASTDP(ptr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm, clinfo3='trd' )
          ENDIF
          !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcdmp.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcdmp.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcdmp.F90	(revision 15648)
@@ -152,5 +152,5 @@
          WRITE(charout, FMT="('dmp ')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl( tab4d_1=CASTWP(ptr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm, clinfo3='trd' )
+         CALL prt_ctl( tab4d_1=CASTDP(ptr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm, clinfo3='trd' )
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcldf.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcldf.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcldf.F90	(revision 15648)
@@ -95,14 +95,14 @@
       CASE ( np_lap   )                                                                                    ! iso-level laplacian
          CALL tra_ldf_lap  ( kt, Kmm, nittrc000,'TRC', zahu, zahv, gtru, gtrv, gtrui, gtrvi,            &
-           &                     CASTWP(ptr(:,:,:,:,Kbb)), ptr(:,:,:,:,Krhs),                   jptra, 1 )
+           &                     CASTDP(ptr(:,:,:,:,Kbb)), ptr(:,:,:,:,Krhs),                   jptra, 1 )
       CASE ( np_lap_i )                                                                                    ! laplacian : standard iso-neutral operator (Madec)
          CALL tra_ldf_iso  ( kt, Kmm, nittrc000,'TRC', zahu, zahv, gtru, gtrv, gtrui, gtrvi,            &
-           &                     CASTWP(ptr(:,:,:,:,Kbb)), CASTWP(ptr(:,:,:,:,Kbb)), ptr(:,:,:,:,Krhs), jptra, 1 )
+           &                     CASTDP(ptr(:,:,:,:,Kbb)), CASTDP(ptr(:,:,:,:,Kbb)), ptr(:,:,:,:,Krhs), jptra, 1 )
       CASE ( np_lap_it )                                                                                   ! laplacian : triad iso-neutral operator (griffies)
          CALL tra_ldf_triad( kt, Kmm, nittrc000,'TRC', zahu, zahv, gtru, gtrv, gtrui, gtrvi,            &
-           &                     CASTWP(ptr(:,:,:,:,Kbb)), CASTWP(ptr(:,:,:,:,Kbb)), ptr(:,:,:,:,Krhs), jptra, 1 )
+           &                     CASTDP(ptr(:,:,:,:,Kbb)), CASTDP(ptr(:,:,:,:,Kbb)), ptr(:,:,:,:,Krhs), jptra, 1 )
       CASE ( np_blp , np_blp_i , np_blp_it )                                                               ! bilaplacian: all operator (iso-level, -neutral)
          CALL tra_ldf_blp  ( kt, Kmm, nittrc000,'TRC', zahu, zahv, gtru, gtrv, gtrui, gtrvi,            &
-           &                     CASTWP(ptr(:,:,:,:,Kbb)) , ptr(:,:,:,:,Krhs),                 jptra, nldf_trc )
+           &                     CASTDP(ptr(:,:,:,:,Kbb)) , ptr(:,:,:,:,Krhs),                 jptra, nldf_trc )
       END SELECT
       !
@@ -118,5 +118,5 @@
          WRITE(charout, FMT="('ldf ')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl( tab4d_1=CASTWP(ptr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm, clinfo3='trd' )
+         CALL prt_ctl( tab4d_1=CASTDP(ptr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm, clinfo3='trd' )
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcrad.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcrad.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcrad.F90	(revision 15648)
@@ -74,5 +74,5 @@
          WRITE(charout, FMT="('rad')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl( tab4d_1=CASTWP(ptr(:,:,:,:,Kbb)), mask1=tmask, clinfo=ctrcnm )
+         CALL prt_ctl( tab4d_1=CASTDP(ptr(:,:,:,:,Kbb)), mask1=tmask, clinfo=ctrcnm )
       ENDIF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcsbc.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcsbc.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trcsbc.F90	(revision 15648)
@@ -190,5 +190,5 @@
       IF( sn_cfctl%l_prttrc )   THEN
          WRITE(charout, FMT="('sbc ')") ;  CALL prt_ctl_info( charout, cdcomp = 'top' )
-                                           CALL prt_ctl( tab4d_1=CASTWP(ptr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm, clinfo3='trd' )
+                                           CALL prt_ctl( tab4d_1=CASTDP(ptr(:,:,:,:,Krhs)), mask1=tmask, clinfo=ctrcnm, clinfo3='trd' )
       ENDIF
       IF( l_trdtrc )  DEALLOCATE( ztrtrd )
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trczdf.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trczdf.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/TRP/trczdf.F90	(revision 15648)
@@ -69,5 +69,5 @@
          WRITE(charout, FMT="('zdf ')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl( tab4d_1=CASTWP(tr(:,:,:,:,Kaa)), mask1=tmask, clinfo=ctrcnm, clinfo3='trd' )
+         CALL prt_ctl( tab4d_1=CASTDP(tr(:,:,:,:,Kaa)), mask1=tmask, clinfo=ctrcnm, clinfo3='trd' )
       END IF
       !
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/trcini.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/trcini.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/trcini.F90	(revision 15648)
@@ -132,5 +132,5 @@
          WRITE(charout, FMT="('ini ')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl( tab4d_1=CASTWP(tr(:,:,:,:,Kmm)), mask1=tmask, clinfo=ctrcnm)
+         CALL prt_ctl( tab4d_1=CASTDP(tr(:,:,:,:,Kmm)), mask1=tmask, clinfo=ctrcnm)
       ENDIF
 9000  FORMAT('      tracer nb : ',i2,'      name :',a10,'      initial content :',e18.10)
Index: /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/trcsms.F90
===================================================================
--- /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/trcsms.F90	(revision 15647)
+++ /NEMO/branches/2021/dev_r14116_HPC-10_mcastril_Mixed_Precision_implementation/src/TOP/trcsms.F90	(revision 15648)
@@ -62,5 +62,5 @@
          WRITE(charout, FMT="('sms ')")
          CALL prt_ctl_info( charout, cdcomp = 'top' )
-         CALL prt_ctl( tab4d_1=CASTWP(tr(:,:,:,:,Kmm)), mask1=tmask, clinfo=ctrcnm )
+         CALL prt_ctl( tab4d_1=CASTDP(tr(:,:,:,:,Kmm)), mask1=tmask, clinfo=ctrcnm )
       ENDIF
       !
